Cutlass CUDA Templates for Linear Algebra Subroutines and Solvers

Public Types | Public Member Functions | Public Attributes | List of all members
cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ > Struct Template Reference

Generic stream for loading and transforming fragments.

`#include <tile_stream.h>`

Inheritance diagram for cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >:

## Public Types
typedef TileLoadStream< Iterator_, Transformer_ > | Base
typedef Iterator_ | Iterator
| TileLoadIterator. More...
typedef PredicateFunctor_ | PredicateFunctor
| Predicate functor. More...
typedef Transformer_ | Transformer
| Transformer. More...
typedef Base::Fragment | Fragment
| Fragment fetched from source memory. More...
typedef Base::TransformedFragment | TransformedFragment
| Output fragment from transformer. More...
typedef Base::Params | Params
| Parameters object used to construct generic load stream. More...
Public Types inherited from cutlass::TileLoadStream< Iterator_, Transformer_ >
typedef Iterator_ | Iterator
| TileLoadIterator. More...
typedef Transformer_ | Transformer
| Transformer. More...
typedef Iterator::Fragment | Fragment
| Fragment fetched from source memory. More...
typedef Transformer::OutputFragment | TransformedFragment
| Output fragment from transformer. More...
typedef Iterator::TensorRef | TensorRef
| Tensor reference expected by the stream. More...
typedef Iterator::Index | Index
| Index type. More...

## Public Member Functions
CUTLASS_DEVICE | PredicatedTileLoadStream (Params const &_params, Coord< 3 > const &bounds, Coord< 3 > const &threadblock_offset=make_Coord(0, 0, 0))
| Ctor. More...
CUTLASS_DEVICE void | copy ()
| Loads a tile and increments the iterator. More...
Public Member Functions inherited from cutlass::TileLoadStream< Iterator_, Transformer_ >
CUTLASS_DEVICE | TileLoadStream (Params const &_params, TensorRef const &_ref)
| Ctor. More...
CUTLASS_DEVICE | TileLoadStream (Params const &_params, Coord< 3 > const &threadblock_offset=make_Coord(0, 0, 0))
| Ctor. More...
CUTLASS_DEVICE void | copy ()
| Loads a tile and increments the iterator. More...
CUTLASS_DEVICE void | commit ()
| Commits the fetched fragment and applies a transformation. More...
CUTLASS_DEVICE Fragment & | intermediate_fragment ()
| Accesses the loaded, transformed fragment. More...
CUTLASS_DEVICE TransformedFragment & | fragment ()
| Accesses the loaded, transformed fragment. More...

## Public Attributes
Iterator::PredicateVector | predicates
| Predicates. More...
Public Attributes inherited from cutlass::TileLoadStream< Iterator_, Transformer_ >
Iterator | iterator
| Iterator to load tiles. More...
Fragment | fetched_fragment
| Fragment loaded via iterator. More...
Transformer | transformer
| Transformation applied to fragments. More...
TransformedFragment | transformed_fragment
| Transformed fragment from transformer. More...

## Member Typedef Documentation

## ◆ Base

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

typedef TileLoadStream<Iterator_, Transformer_> cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::Base

## ◆ Fragment

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

typedef Base::Fragment cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::Fragment

## ◆ Iterator

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

typedef Iterator_ cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::Iterator

## ◆ Params

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

typedef Base::Params cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::Params

## ◆ PredicateFunctor

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

typedef PredicateFunctor_ cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::PredicateFunctor

## ◆ TransformedFragment

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

typedef Base::TransformedFragment cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::TransformedFragment

## ◆ Transformer

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

typedef Transformer_ cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::Transformer

## Constructor & Destructor Documentation

## ◆ PredicatedTileLoadStream()

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

CUTLASS_DEVICE cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::PredicatedTileLoadStream | ( | Params const & | _params,
|  | Coord< 3 > const & | bounds,
|  | Coord< 3 > const & | threadblock_offset = `make_Coord(0, 0, 0)`
| ) |  |
| inline

## Member Function Documentation

## ◆ copy()

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

CUTLASS_DEVICE void cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::copy | ( |  | ) |
| inline

## Member Data Documentation

## ◆ predicates

template<typename Iterator_ , typename PredicateFunctor_ = RegularTilePredicateFunctor<typename Iterator_::Traits::Delta>, typename Transformer_ = Copy<typename Iterator_::Fragment>>

Iterator::PredicateVector cutlass::PredicatedTileLoadStream< Iterator_, PredicateFunctor_, Transformer_ >::predicates

The documentation for this struct was generated from the following file:

- tile_stream.h